#include<stdio.h>
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include "GL/glut.h"

template <class dataType>
class Texture3DLoader {
    
    
    public:
        int width,height,depth;
        dataType min,max;
        dataType * data;
        float * transFunc;
        
        
        Texture3DLoader() {//transFunc = new float*[4];
                            }
        ~Texture3DLoader() {delete data;
                            delete transFunc;
                            }
        
        int Texture3DLoader::loadRAWfile(char* name, int w,int h,int d)
            {
            width = w; height = h; depth = d;
            size_t count;
          	FILE *fp;
            long size = width*height*d;
            //Error handling 
            
            //Try to read the file
        	if (name != NULL) {
        		fp = fopen(name,"r");
                
                //If file ok, read the data. Return 1 as in OK
        		if (fp != NULL) {     
                        //data = dataType[size];
             			data = (dataType *)malloc(sizeof(dataType) * size);
        				count = fread(data,sizeof(dataType),size,fp);
        				minMax();
        				
                            
                        return 1;
        		}
        		//If filepointer not ok return 0
        		else return 0;
        			fclose(fp);
        		}
        		//If filename is null return 0
                else return 0;
            };
        
         void Texture3DLoader::minMax()
            {
            min = (dataType)255;
            max = (dataType)0;
            int counter = 0;
            dataType * pointer;
              for(pointer=data; pointer<data+(width*height*depth);pointer++)
                {
                    if(*pointer<min) min = *pointer;
                    else if(*pointer>max) max = *pointer;
                    counter++;
                }
            
            transFunc = (float*)malloc(sizeof(float) * 4 * (max-min));
            //std::cout<< counter << " " << width*depth*height << std::endl << (int)min << " " << (int)max << std::endl;
            };
            
        
        //Makes a quadratic function from low to high in the choosen transferfunction
        void Texture3DLoader::setQuadTransFunc(int func, float low, float high)
            {
                int minReal = (int)((float)(max-min)*low);
               // if(minReal<0) minReal=0;
                
                int maxReal = (int)((float)(max-min)*high);
               // if(maxReal>max) maxReal = max;
                
                int top = (maxReal-minReal)/2;
                float * pointer = transFunc+minReal;
                
          
                
                while(pointer!=transFunc+maxReal) 
                    {
                    *pointer = 1.0 - (float)(( (float)(minReal-top)/(top*2.0f) ) * (float)(minReal-top)/(top*2.0f));
                    //std::cout << *pointer << std::endl;
                    pointer++;
                    minReal++;
                    }
            };        
};
