#include "shaderLoad.h"
#include "FPScalculator.h"
#include "Texture3DLoader.h"
#include "inputController.h"

float lightPos[4] = {0,0,2,0};

FPScalculator * fpscalc = new FPScalculator();
Texture3DLoader <char> * t3DLoader = new Texture3DLoader<char>();

char titlestring[400];

char* fragmentName = "minimal.frag";
char* vertexName = "minimal.vert";

GLuint shader_program;
GLuint vtexture;

GLfloat cameraPos[] = {0.0f,0.0f,5.0f};

static float TIME;

/* GLUT callback Handlers */
static void resize(int width, int height)
{ 
    glViewport(0, 0, width, height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    // 45 degrees FOV, same aspect ratio as viewport, depth range 0.1 to 1000
    gluPerspective( 45.0f, (GLfloat)width/(GLfloat)height, 0.1f, 1000.0f );
    
    // Select and setup the modelview matrix.
    glMatrixMode( GL_MODELVIEW ); // "We want to edit the modelview matrix"
    glLoadIdentity(); // Reset the matrix to identity
    // Look from 0,-4,0 towards 0,0,0 with Z as "up" in the image
    gluLookAt( cameraPos[0], cameraPos[1], cameraPos[2],  // Eye position
               0.0f, 0.0f, 0.0f,   // View point
               0.0f, 1.0f, 0.0f ); // Up vector
}

void drawTexturedQuad(int x, int z)
{
        glBegin(GL_QUADS);
                   glNormal3f(0,0,-1); 
                   glTexCoord2f(0.0f, 0.0f); glVertex3d(-x,0,-z);
                   glNormal3f(0,0,-1); 
                   glTexCoord2f(1.0f, 0.0f); glVertex3d(x,0,-z);
                   glNormal3f(0,0,-1); 
                   glTexCoord2f(1.0f, 1.0f); glVertex3d(x,0,z);
                   glNormal3f(0,0,-1); 
                   glTexCoord2f(0.0f, 1.0f); glVertex3d(-x,0,z);
        glEnd();
}

void drawBoundingBox(float size)
{
float x1 = -size/2.0;
float y1 = size/2.0;
float z1 = size/2.0;
float x2 = size/2.0;
float y2 = -size/2.0;
float z2 = -size/2.0;

float v1[] = {x1,y1,z1}; float tv1[] = {0,1,1};
float v2[] = {x2,y1,z1}; float tv2[] = {1,1,1};
float v3[] = {x2,y2,z1}; float tv3[] = {1,0,1};
float v4[] = {x1,y2,z1}; float tv4[] = {0,0,1};
float v5[] = {x2,y1,z2}; float tv5[] = {1,1,0};
float v6[] = {x2,y2,z2}; float tv6[] = {1,0,0};
float v7[] = {x1,y1,z2}; float tv7[] = {0,1,0};
float v8[] = {x1,y2,z2}; float tv8[] = {0,0,0};
glFrontFace(GL_CW);
glBegin(GL_QUADS);

    //front
    //glColor3f(0,1,0);
    glNormal3f(0,0,1); glTexCoord3fv(tv1); glVertex3fv(v1);
    glNormal3f(0,0,1); glTexCoord3fv(tv2); glVertex3fv(v2);
    glNormal3f(0,0,1); glTexCoord3fv(tv3); glVertex3fv(v3);
    glNormal3f(0,0,1); glTexCoord3fv(tv4); glVertex3fv(v4);

    //glColor3f(1,0,0);    
    //right
      glNormal3f(1,0,0); glTexCoord3fv(tv2); glVertex3fv(v2);
      glNormal3f(1,0,0); glTexCoord3fv(tv5); glVertex3fv(v5);
      glNormal3f(1,0,0); glTexCoord3fv(tv6); glVertex3fv(v6);
      glNormal3f(1,0,0); glTexCoord3fv(tv3); glVertex3fv(v3); 

    
    //back
      glNormal3f(0,0,-1); glTexCoord3fv(tv5); glVertex3fv(v5); 
      glNormal3f(0,0,-1); glTexCoord3fv(tv7); glVertex3fv(v7); 
      glNormal3f(0,0,-1); glTexCoord3fv(tv8); glVertex3fv(v8); 
      glNormal3f(0,0,-1); glTexCoord3fv(tv6); glVertex3fv(v6); 
    
    
    //left
    glNormal3f(-1,0,0); glTexCoord3fv(tv7); glVertex3fv(v7); 
    glNormal3f(-1,0,0); glTexCoord3fv(tv1); glVertex3fv(v1); 
    glNormal3f(-1,0,0); glTexCoord3fv(tv4); glVertex3fv(v4);
    glNormal3f(-1,0,0); glTexCoord3fv(tv8); glVertex3fv(v8);
    
    
    //top
    glNormal3f(0,1,0); glTexCoord3fv(tv1); glVertex3fv(v1); 
    glNormal3f(0,1,0); glTexCoord3fv(tv7); glVertex3fv(v7); 
    glNormal3f(0,1,0); glTexCoord3fv(tv5); glVertex3fv(v5);
    glNormal3f(0,1,0); glTexCoord3fv(tv2); glVertex3fv(v2); 
    
    //bottom
    glNormal3f(0,-1,0); glTexCoord3fv(tv4); glVertex3fv(v4);
    glNormal3f(0,-1,0); glTexCoord3fv(tv3); glVertex3fv(v3);
    glNormal3f(0,-1,0); glTexCoord3fv(tv6); glVertex3fv(v6);
    glNormal3f(0,-1,0); glTexCoord3fv(tv8); glVertex3fv(v8);
    


glEnd();
}


static void display(void)
{
    TIME = glutGet(GLUT_ELAPSED_TIME);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);     
    glEnable(GL_TEXTURE_3D);   
    glActiveTexture(GL_TEXTURE0);
    glBindTexture(GL_TEXTURE_3D, vtexture);     
    //cameraPos[0] = 5*sin(TIME/1000.0f);
    //cameraPos[1] = 5*cos(TIME/1000.0f);
    //Send the camerapos vector to the shader
    glUniform1f(glGetUniformLocation(shader_program,"time"),TIME);
    glUniform1f(glGetUniformLocation(shader_program,"troskel"),troskel);
    glUniform1f(glGetUniformLocation(shader_program,"troskelr"),troskelr);
    glUniform1f(glGetUniformLocation(shader_program,"troskelg"),troskelg);
    glUniform1f(glGetUniformLocation(shader_program,"troskelb"),troskelb);
    
    glUniform1i(glGetUniformLocation(shader_program,"vtexture"),0);
   // glUniform1f(glGetUniformLocation(shader_program,"bBoxSize"),2); 
       
    //Calculate the fps and display in the window title.
    fpscalc->calcFPS(TIME);
    sprintf(titlestring, "Fnster % .1f FPS  % .1f MAX % .1f MIN  RUNTIME: %.1f",fpscalc->FPS,fpscalc->max,fpscalc->min,TIME);
    glutSetWindowTitle(titlestring); 
    
    //Set the light position, varied by time
    //lightPos[0] = 5*sin(TIME/1000.0f);
    
    glColor3d(1,0,0);
    glPushMatrix();
        glLightfv(GL_LIGHT0, GL_POSITION, lightPos);
    glPopMatrix();

    glPushMatrix();
        glTranslated(0,0,translateZ+tZ);
        
        glRotatef(rotateX+rX,0,1,0);
        
        glRotatef(rotateY+rY,1,0,0);
            
        
        
        //glutSolidSphere(1,30,30);
 //       drawTexturedQuad(5, 5);
            drawBoundingBox(2);
                   
    glPopMatrix();

    glutSwapBuffers();
}




static void idle(void)
{
    glutPostRedisplay();
}




/* Program entry point */
int main(int argc, char *argv[])
{
    glutInit(&argc, argv);
    glutInitWindowSize(640,480);
    glutInitWindowPosition(10,10);
    glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
    
    
    glutCreateWindow("A window with stuff");

    glutReshapeFunc(resize);
    glutDisplayFunc(display);
    
    glutIdleFunc(idle);
    
    
    glutKeyboardFunc(key);
	glutMouseFunc(mouse);
	glutMotionFunc(motionFunc);
    
    glClearColor(0,0,0,0);
    glEnable(GL_CULL_FACE);
    glCullFace(GL_BACK);

    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);
    
    glEnable(GL_LIGHT0);
    glEnable(GL_NORMALIZE);
    glEnable(GL_COLOR_MATERIAL);
    glEnable(GL_LIGHTING);
 
  
    
    fpscalc->updateRate=200;
    
    
    glewInit();
   	if (!glewIsSupported("GL_VERSION_2_0"))
   	{
		MessageBox (NULL, "No Opengl 2.0 support, shaders can not be used" , "Error", 0);
	}
	else std::cout << "Shaders supported!\n";
    
    setShaderProgram(&shader_program,vertexName,fragmentName);
    glUseProgram(shader_program);
    
    if(t3DLoader->loadRAWfile("data/skull_256x256x256_8.raw",256,256,256)==0)
    //if(t3DLoader->loadRAWfile("data/bonsai256x256x256.raw",256,256,256)==0)
    //if(t3DLoader->loadRAWfile("data/CThip2_104x139x227_u8.raw",104,139,227)==0)
    ///if(t3DLoader->loadRAWfile("data/lobster301x324x56.raw",301,324,56)==0)
    //if(t3DLoader->loadRAWfile("data/foot.raw",256,256,256)==0)
    //if(t3DLoader->loadRAWfile("data/BostonTeapot.raw",256,256,178)==0)
    //if(t3DLoader->loadRAWfile("data/backpack8.raw",512,512,373)==0)
        {
            MessageBox (NULL, "Failed to load data" , "Error", 0);
        }
       
    std::cout << "3D texture file read\n";
    
    glEnable(GL_TEXTURE_3D);       
    glGenTextures(1, &vtexture);
    glBindTexture(GL_TEXTURE_3D, vtexture);
    glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_WRAP_R, GL_CLAMP);
    glTexImage3D(GL_TEXTURE_3D, 0, GL_INTENSITY,t3DLoader->width,t3DLoader->height,t3DLoader->depth, 0, GL_LUMINANCE, GL_UNSIGNED_BYTE, t3DLoader->data);
    std::cout<< "Texture loaded!" << std::endl;
    
    t3DLoader->setQuadTransFunc(0,0.5,1.0);
    
    glutMainLoop();

    return EXIT_SUCCESS;
}

