//Volume fragment shader
//Jonas Nilsson

varying vec3 lightDir;
varying vec4 tCoord3D;
varying vec4 position;

uniform float time;
uniform sampler3D vtexture;
uniform float troskel;
uniform float troskelr;
uniform float troskelg;
uniform float troskelb;

#define sq(a) a*a

bool inside(float x) {
return ( (x>=0 && x<=1) ? 1 : 0);
}

//thanks lumina.sourceforge.net
float rand(vec2 co){

        return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);

        }

void main()
{ 
    float stepSize = 0.01;	
    
    //the inverse of the modelview matrix is ued for retrieving the camera position	
    //thanks veronica 
    mat4 modelViewMatrixInverse = gl_ModelViewMatrixInverse;
    vec4 cameraPosition = modelViewMatrixInverse[3];
    
    vec4 color = {0.0,0.0,0,1.0};
    
    //Compute ray start point and ray direction
    //The position vector is the nontransformed position. As the cameraPosition from the 
    //viewmatrixinverse is the transformed cameraposition. I guess
    vec4 ray = tCoord3D;
    vec4 rayDir = stepSize*normalize((position-cameraPosition))*gl_TextureMatrix[0];
	ray+=rayDir*rand(ray.xy);    
    
    float alpha = 0.0; 
     
    for(int i = 0; i <100; i++)
    {
	float distfog = 1f-((float)i/100f);
	color.r += (1-alpha)*smoothstep(troskelr,troskelr+0.2,texture3D(vtexture,ray.xyz))*distfog;
	color.g += (1-alpha)*smoothstep(troskelg,troskelg+0.2,texture3D(vtexture,ray.xyz))*distfog;
    color.b += (1-alpha)* smoothstep(troskelb,troskelb+0.2,texture3D(vtexture,ray.xyz).a)*distfog;
    
    alpha += (1-alpha)* smoothstep(troskel,troskel+0.2,texture3D(vtexture,ray.xyz).a)*distfog;
   
    
    if(color.r>1 || !(inside(ray.x) && inside(ray.y) && inside(ray.z)) ) break;    
	ray += rayDir;
    }
    
	gl_FragColor = color;
}
